/* *****************************************************************/
/* For Lightning 0.8, if installed                                 */
/* *****************************************************************/
window.addEventListener("load", LightningCompatibility, false);

/* Set up Lightning compatibility */
function LightningCompatibility() {
  window.removeEventListener("load", LightningCompatibility, false);
  if (!document.getElementById("ltnModeBox"))
    return;

  // Set deck index for css to reclaim ltnSidebar space when folderpane is selected
  if (document.getElementById("contentPanel").selectedPanel.id == "folderPaneBox")
    document.getElementById("contentPanel").setAttribute("selectedIndex", "0");

  // Override command to switch into Calendar mode
  var _ltnSwitch2Calendar = ltnSwitch2Calendar;
  ltnSwitch2Calendar = function ltnSwitch2Calendar() {
    if([3,4].indexOf(pref.getIntPref('mail.pane_config.dynamic')) != -1 && 
        gCurrentMode == 'mail') { 
      UpdateMailPaneConfig(false);
      gCompositeCalendar = null;
    }
    
    _ltnSwitch2Calendar();
    ltnMinimonthPick(getMinimonth());

    if (gDOMChangedFolderPaneOrThreadPane) { 
      document.getElementById('displayDeck')
          .addEventListener('dayselect', observeViewDaySelect, false);
      unifinderTreeView.treeElement.view = unifinderTreeView;
      taskViewUpdate(document.getElementById('task-tree-filter').value);
      document.getElementById('event-filter-menupopup')
          .removeAttribute('menugenerated');
      gDOMChangedFolderPaneOrThreadPane = false;
    } 
  }

  // Override command to switch into Task mode
  var _ltnSwitch2Task = ltnSwitch2Task;
  ltnSwitch2Task = function ltnSwitch2Task() {
    if([3,4].indexOf(pref.getIntPref('mail.pane_config.dynamic')) != -1 && 
        gCurrentMode == 'mail') {
      UpdateMailPaneConfig(false);
      gCompositeCalendar = null;
    }

    _ltnSwitch2Task();

    if (gDOMChangedFolderPaneOrThreadPane) { 
      document.getElementById('displayDeck')
          .addEventListener('dayselect', observeViewDaySelect, false);
      unifinderTreeView.treeElement.view = unifinderTreeView;
      taskViewUpdate(document.getElementById('task-tree-filter').value); 
      document.getElementById('event-filter-menupopup')
          .removeAttribute('menugenerated');
      gDOMChangedFolderPaneOrThreadPane = false;
    }
  }
/*
  // Command to switch into Calendar mode
  var switch2cal = document.getElementById('switch2calendar');
  if (switch2cal)
    switch2cal.setAttribute("oncommand", 
        "if([3,4].indexOf(pref.getIntPref('mail.pane_config.dynamic')) > -1 && " +
            "gCurrentMode == 'mail') { " +
          "UpdateMailPaneConfig(false); " +
          "gCompositeCalendar = null; " +
        "} " +

        "ltnMinimonthPick(getMinimonth()); " +
        "ltnSwitch2Calendar(); " +

        "if (gDOMChangedFolderPaneOrThreadPane) { " +
          "document.getElementById('displayDeck')" +
              ".addEventListener('dayselect', observeViewDaySelect, false); " +
          "unifinderTreeView.treeElement.view = unifinderTreeView; " +
          "taskViewUpdate(document.getElementById('task-tree-filter').value); " +
          "document.getElementById('event-filter-menupopup')" +
              ".removeAttribute('menugenerated'); " +
          "gDOMChangedFolderPaneOrThreadPane = false; " +
        "} " 
        );

  // Command to switch into Task mode
  var switch2task = document.getElementById('switch2task');
  if (switch2task)
    switch2task.setAttribute("oncommand", 
        "if([3,4].indexOf(pref.getIntPref('mail.pane_config.dynamic')) != -1 && " +
            "gCurrentMode == 'mail') { " +
          "UpdateMailPaneConfig(false); " +
          "gCompositeCalendar = null; " +
        "} " +

        "ltnSwitch2Task(); " +

        "if (gDOMChangedFolderPaneOrThreadPane) { " +
          "document.getElementById('displayDeck')" +
              ".addEventListener('dayselect', observeViewDaySelect, false); " +
          "unifinderTreeView.treeElement.view = unifinderTreeView; " +
          "taskViewUpdate(document.getElementById('task-tree-filter').value); " +
          "document.getElementById('event-filter-menupopup')" +
              ".removeAttribute('menugenerated'); " +
          "gDOMChangedFolderPaneOrThreadPane = false; " +
        "} " 
        );
*/
  makeLtnModeButtonsCustomizable();
  UpdateLightningTodayPaneConfig();
}

/* Lightning (0.8) Today Pane layout */
function UpdateLightningTodayPaneConfig() {
  var paneConfig = pref.getIntPref("mail.pane_config.dynamic");
  var paneConfigLtn = pref.getIntPref("extensions.morelayoutsfortb.calendar.todaypane_config.dynamic");
  var insertWhere;
  var todayPanePanel = document.getElementById('today-pane-panel');
  var todayPaneSplitter = document.getElementById('today-splitter');

  if (paneConfigLtn == 1) {
    // Move to Folderpane
    if (paneConfig != kStackedPaneConfig || gAccountCentralLoaded) {
      insertWhere = document.getElementById("contentPanel");
      insertWhere.parentNode.insertBefore(todayPanePanel, insertWhere.nextSibling);
      insertWhere.parentNode.insertBefore(todayPaneSplitter, insertWhere.nextSibling);
    }
    // If stacked, it goes in the original DOM location
    else if (paneConfig == kStackedPaneConfig) {
      insertWhere = document.getElementById("mailContent");
      insertWhere.appendChild(todayPaneSplitter);
      insertWhere.appendChild(todayPanePanel);
    }
    
    // Need to reinit Today Pane completely..
//    gCompositeCalendar = null;
    agendaListbox.showstoday = false;

    agendaListbox.removeListItems();
    var today = document.getElementById("today-header");
    today.parentNode.removeChild(today);
    var tomorrow = document.getElementById("tomorrow-header");
    tomorrow.parentNode.removeChild(tomorrow);
    var soon = document.getElementById("nextweek-header");
    soon.parentNode.removeChild(soon);
    var viewlayouttodaypane = document.getElementById("menu_showTodayPane");
    viewlayouttodaypane.parentNode.removeChild(viewlayouttodaypane);
    
    loadTodayPane();
    toDoUnifinderRefresh();
  }
}

/* Make Lightning mode-toolbar items Customizable in main toolbars */
function makeLtnModeButtonsCustomizable() {
  var mailToolbox = document.getElementById('mail-toolbox');
  var modeToolbox = document.getElementById('mode-toolbox');
  if (modeToolbox) {
    var item = modeToolbox.palette.firstChild;
    while (item) {
      item.setAttribute('checked', false);
      var cloneItem = item.cloneNode(true);
      cloneItem.setAttribute('mode', 'mail');
      mailToolbox.palette.appendChild(cloneItem);
      var cloneItemCal = item.cloneNode(true);
      cloneItemCal.setAttribute('mode', 'calendar');
      cloneItemCal.setAttribute('id', cloneItemCal.getAttribute('id')+'-cal');
      mailToolbox.palette.appendChild(cloneItemCal);
      var cloneItemTask = item.cloneNode(true);
      cloneItemTask.setAttribute('mode', 'task');
      cloneItemTask.setAttribute('id', cloneItemTask.getAttribute('id')+'-task');
      mailToolbox.palette.appendChild(cloneItemTask);
      item = item.nextSibling;
    }
    // Palette items not there yet when toolbars built, so reset them now..
    var toolbar = mailToolbox.firstChild
    while (toolbar) {
      if (toolbar.localName == "toolbar")
        toolbar.currentSet = toolbar.getAttribute("currentset");
      toolbar = toolbar.nextSibling;
    }
  }
}
